//////////////////////////////////////////////////////////////////////////////
//   ///////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#include "stdafx.h"
#include "_DRAW_2D.h"

//////////////////////////////////////////////////////////////////////////////
//    /////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#define WAIT 85

int keyExit = 0, pause = 0;

void keyPressed()                           //  [ ] 
{
  keyExit = (II.KeyUp[_Esc_]);
  II.Reset();
};

//////////////////////////////////////////////////////////////////////////////
//     /////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
#define COLORS 9

int aLayers = 8, aCount = 12, aTry = 27, pColor, rColor, iColor, mColor, hColor, aRotate;
tfloat aRad = 128, aSpace = 1;

dwRGB aColorsB1[COLORS] = {RGBis(255, 155, 0), RGBis(0, 155, 255), RGBis(255, 125, 0), RGBis(185, 225, 0), RGBis(255, 155, 0), RGBis(255, 0, 0), RGBis(255, 155, 0), RGBis(255, 0, 115), RGBis(255, 155, 100)};
dwRGB aColorsB2[COLORS] = {RGBis(75, 0, 0),    RGBis(0, 15, 115),  RGBis(0, 100, 255), RGBis(0, 45, 0),    RGBis(200, 0, 50),  RGBis(55, 0, 0),  RGBis(185, 225, 0), RGBis(100, 0, 150), RGBis(0, 70, 100)};

dwRGB aColorsW1[COLORS] = {RGBis(200, 50, 0),    RGBis(0, 50, 100),    RGBis(255, 135, 0),   RGBis(80, 125, 0),   RGBis(255, 100, 0),   RGBis(155, 0, 0),     RGBis(200, 0, 50),    RGBis(155, 0, 55),   RGBis(0, 70, 100)};
dwRGB aColorsW2[COLORS] = {RGBis(255, 200, 100), RGBis(100, 155, 255), RGBis(175, 175, 255), RGBis(155, 225, 75), RGBis(255, 175, 225), RGBis(255, 155, 100), RGBis(255, 155, 100), RGBis(175, 100, 255), RGBis(255, 155, 100)};

dwRGB aColor, aColor1, aColor2 = 0;

void paramsStart()
{
  aRad *= (tfloat)DrawXR * DrawYR / (1280 * 1024);
  pColor = Random(COLORS - 1);
};

void paramsChange()
{
  if (Random(1)) 
  { aColor1 = aColorsB1[pColor];
    aColor2 = aColorsB2[pColor];
    if (Random(1)) Swap(aColor1, aColor2);
    VS_CColor = RGBis(0, 0, 0);  
  } else { aColor1 = aColorsW1[pColor];
           aColor2 = aColorsW2[pColor];
           VS_CColor = RGBaddV(aColor2, 55);
         };
  pColor = (pColor + 1) % COLORS;
  rColor = Random(1);
  iColor = Random(1);
  mColor = Random(1);
  hColor = Random(2);
  aRotate = Random(1);
};

void colorSet(int l)
{
  if (rColor) aColor = RGBblend(aColor1, aColor2, Random(255));
  else aColor = RGBblend(aColor1, aColor2, 255 * l / (aLayers - 1));
};

/////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsInit()
{ 
  RandomSeed();
  Draw2D_Init();
  paramsStart();
  ForceActivate();
  ScreenLoadWait();
  OnKeyUpDo(keyPressed);       //     
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void CommonsDone()
{
  Draw2D_Done();
};

////////////////////////////////////////////////////////////////////////////////////////
int optmSegs(tfloat r)
{
  if (r < 3) return 4; else
  if (r < 7) return 8; else
  if (r < 15) return 16; else
  if (r > 2000) return 90; else return 16 + 74 * Power((r - 15) / 1993, 0.75); 
};

//////////////////////////////////////////////////////////////////////////////////////////////////
inline int pointFree(tfloat x, tfloat y)
{
  DPRconv(x, y);
  unsigned xx = (unsigned)x, yy = (unsigned)y;
  if ((xx > DrawXL) || (yy > DrawYL)) return Yes;
  else return (* (DrawPointPtr(xx, yy)) == VS_CColor);
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int spaceCircleFree(int &x, int &y, tfloat r)
{
  if (!pointFree(x = Random(DrawXL), y = Random(DrawYL))) return no;
  DrawPolyRotateNo();
  r += aSpace;
  int s = optmSegs(r);
  for (int i = 0; i < s; i++)
  { tfloat a = M_PI * i * 2 / s;
    if (!pointFree(x - cos(a) * r, y + sin(a) * r)) return no;
  };
  return Yes;
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int spaceSquareFree(int &x, int &y, tfloat r)
{
  if (!pointFree(x = Random(DrawXL), y = Random(DrawYL))) return no;
  r += aSpace;
  if (aRotate) DrawPolyRotate(x, y, M_PI / 4); else DrawPolyRotateNo();
  if (!pointFree(x - r, y - r)) return no;
  if (!pointFree(x + r, y + r)) return no;
  if (!pointFree(x + r, y - r)) return no;
  if (!pointFree(x - r, y + r)) return no;
  if (!pointFree(x - r, y)) return no;
  if (!pointFree(x + r, y)) return no;
  if (!pointFree(x, y - r)) return no;
  if (!pointFree(x, y + r)) return no;
  return Yes;
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int Allocated;

void circleAllocate(tfloat r, int l)
{ 
  int x, y;
  r += fRandom(-r * 0.25, r * 0.25);
  for (int i = 0; i < aTry; i++)
  if (spaceCircleFree(x, y, r))
  { colorSet(l);
    DrawCircle(x, y, r, RGBadd(aColor, RGBmultV(aColor, Random(0, 55))));
    if (iColor && (r > 1.5)) 
    if (hColor == 1) DrawCircle(x, y, r * 0.75, VS_CColor);
    else DrawCircle(x, y, r * 0.75, RGBmultV(aColor, 35), modeADD + mColor);
    Allocated = Yes; return;
  };
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void rsquareAllocate(tfloat r, int l)
{ 
  int x, y;
  tfRegion rg;
  r += fRandom(-r * 0.25, r * 0.25); r = ceil(r);
  for (int i = 0; i < aTry; i++)
  if (spaceSquareFree(x, y, r))
  { colorSet(l);
    rg = fRegionIs(x - r, y - r, x + r, y + r);
    fDrawRoundRect(rg, r * 0.5, RGBadd(aColor, RGBmultV(aColor, Random(0, 55))));
    if (iColor && (r > 1.5))
    { tfloat rr = r * 0.75;
      rg = fRegionIs(x - rr, y - rr, x + rr, y + rr);
      if (hColor == 1) fDrawRoundRect(rg, r * 0.5 - (r - rr), VS_CColor);
      else fDrawRoundRect(rg, r * 0.5 - (r - rr), RGBmultV(aColor, 35), modeADD + mColor);
    };
    Allocated = Yes; return;
  };
};

//////////////////////////////////////////////////////////////////////////////////////////////////
void squareAllocate(tfloat r, int l)
{ 
  int x, y;
  tfRegion rg;
  r += fRandom(-r * 0.25, r * 0.25); r = ceil(r);
  for (int i = 0; i < aTry; i++)
  { if (spaceSquareFree(x, y, r))
    { colorSet(l);
      rg = fRegionIs(x - r, y - r, x + r, y + r);
      fDrawRect(rg, RGBadd(aColor, RGBmultV(aColor, Random(0, 55))));
      if (iColor && (r > 1.5))
      { r *= 0.75; rg = fRegionIs(x - r, y - r, x + r, y + r);
        fDrawRect(rg, RGBmultV(aColor, 35), modeADD + mColor);
      };
      Allocated = Yes; return;
    };
  };
};

//////////////////////////////////////////////////////////////////////////////////////////////////
int aForm;

void formAllocate(tfloat r, int l)
{
  switch(aForm)
  { case 0: circleAllocate(r, l); break;
    case 1: rsquareAllocate(r, l); break;
    case 2: squareAllocate(r, l); break;
  };
};

//////////////////////////////////////////////////////////////////////////////////////////////////
float f;                                

void DrawAll()
{
  tfloat r = aRad * 3.0 / (3 + Random(2));
  int c = aCount; 
  paramsChange();
  DrawClear();
  aForm = Random(2);
  for (int i = 0; i < aLayers; i++)
  { Allocated = no;
    for (int j = 0; j < c; j++) { formAllocate(r, i); if (keyExit) return; };
    DrawPaint();
    r *= 0.5; c *= 4;
    if (!Allocated || (r < 0.25)) break;    
  };
};

//////////////////////////////////////////////////////////////////////////////
//   //////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////
void Main()
{
  CommonsInit();                  //   ;  
  
  while (Yes)
   { DrawAll();
     for (int i = 0; i < 30; i++) if (!keyExit) Sleep(100);
     if (keyExit) break; 
   };   

  CommonsDone();                  //   ;
};
//////////////////////////////////////////////////////////////////////////////
int LetProcess()
{
  MouseShowCursor = no;
  WinName = L"CG : Allocation";   //    
  VS_CColor = RGBis(255, 255, 255);    //   
  DrawSet(FullScreen);         //   ( )  , FullScreen   
  ProcessFunc = Main;           //    -  
  return on;
};
int Init_LetProcess = LetProcess();

